#!/bin/sh
# ##########################################################################
# ####                                                                  ####
# ####                      RTP Audio Server Project                    ####
# ####                    ============================                  ####
# ####                                                                  ####
# #### Backup Script                                                    ####
# ####                                                                  ####
# #### Version 1.00, January 05, 2000                                   ####
# ####                                                                  ####
# #### Copyright (C) 1999  Thomas Dreibholz                             ####
# ####               2000  Universitt Bonn, Abt. IV                    ####
# ####                     EMail: Dreibholz@bigfoot.com                 ####
# ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
# ####                                                                  ####
# ##########################################################################


if [ ! $# -gt 0 ]
then
   echo "Usage: Backup.sh [Directory]"
   exit
fi

if [ ! -e $1 ]
then
   mkdir $1
fi

if [ ! -e $1 ]
then
   echo "Directory $1 does not exist!"
   exit
fi

make clean


if [ ! -e $1/rtpaudio ]
then
   mkdir $1/rtpaudio
fi
if [ ! -e $1/rtpaudio/Java ]
then
   mkdir $1/rtpaudio/Java
fi
if [ ! -e $1/rtpaudio/FlowLabel ]
then
   mkdir $1/rtpaudio/FlowLabel
fi
if [ ! -e $1/rtpaudio/Ablage ]
then
   mkdir $1/rtpaudio/Ablage
fi
if [ ! -e $1/rtpaudio/QoS ]
then
   mkdir $1/rtpaudio/QoS
fi
if [ ! -e $1/rtpaudio/ResvMod ]
then
   mkdir $1/rtpaudio/ResvMod
fi
if [ ! -e $1/rtpaudio/Konzept ]
then
   mkdir $1/rtpaudio/Konzept
fi

cp -d * $1/rtpaudio
cp -d Java/* $1/rtpaudio/Java
cp -d FlowLabel/* $1/rtpaudio/FlowLabel
cp -d Ablage/*.cc Ablage/*.h Ablage/*.txt Ablage/*.tex Ablage/*.tex.gz $1/rtpaudio/Ablage
cp -d QoS/* $1/rtpaudio/QoS
cp -d ResvMod/* $1/rtpaudio/ResvMod
cp -d Konzept/* $1/rtpaudio/Konzept


echo ""
echo "Backup to $1 completed!"
echo ""
