// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Transport Info Implementation                                    ####
// ####                                                                  ####
// #### Version 1.00, February 25, 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://titan.cs.uni-bonn.de/~dreibhol ####
// ####                                                                  ####
// ##########################################################################


#include "transportinfo2.h"
#include "../range.h"
#include "../tools.h"


namespace Coral {


// ###### Constructor #######################################################
TransportInfo2::TransportInfo2()
{
}


// ###### Reset #############################################################
/*
void TransportInfo::reset()
{
   WantedBytesPerSecond.init(0,0,0);
   WantedFramesPerSecond.init(0,0,0);
   WantedPacketsPerSecond.init(0,0,0);
   WantedExtensionBytesPerSecond   = 0;
   WantedExtensionPacketsPerSecond = 0;
   WantedMaxTransferDelay          = (card32)-1;
   WantedMaxExtensionTransferDelay = (card32)-1;
   Flags                 = TIF_None;
   TrafficClass          = 0x00;
   ExtensionTrafficClass = 0x00;
   QualityLevels = 0;
   for(card32 i = 0;i < MaxQualityLevels;i++) {
      QualityLevel[i].BytesPerSecond            = 0;
      QualityLevel[i].ExtensionBytesPerSecond   = 0;
      QualityLevel[i].FramesPerSecond           = 0;
      QualityLevel[i].PacketsPerSecond          = 0;
      QualityLevel[i].ExtensionPacketsPerSecond = 0;
      QualityLevel[i].MaxTransferDelay          = (card32)-1;
      QualityLevel[i].MaxExtensionTransferDelay = (card32)-1;
      QualityLevel[i].Quality                   = 0;
      QualityLevel[i].LossRate                  = 0;
      QualityLevel[i].LevelUp                   = 0xff;
      QualityLevel[i].LevelDown                 = 0xff;
   }
   CurrentSetting.BytesPerSecond            = 0;
   CurrentSetting.ExtensionBytesPerSecond   = 0;
   CurrentSetting.FramesPerSecond           = 0;
   CurrentSetting.PacketsPerSecond          = 0;
   CurrentSetting.ExtensionPacketsPerSecond = 0;
   CurrentSetting.Quality                   = 0;
   CurrentSetting.LossRate                  = 255;
   CurrentSetting.LevelUp                   = 0xff;
   CurrentSetting.LevelDown                 = 0xff;
}
*/

// ###### Translate byte order ##############################################
/*
void TransportInfo::translate()
{
   WantedBytesPerSecond.Min      = translate64(WantedBytesPerSecond.Min);
   WantedBytesPerSecond.Max      = translate64(WantedBytesPerSecond.Max);
   WantedBytesPerSecond.Value    = translate64(WantedBytesPerSecond.Value);
   WantedExtensionBytesPerSecond = translate64(WantedExtensionBytesPerSecond);

   WantedFramesPerSecond.Min   = translate32(WantedFramesPerSecond.Min);
   WantedFramesPerSecond.Max   = translate32(WantedFramesPerSecond.Max);
   WantedFramesPerSecond.Value = translate32(WantedFramesPerSecond.Value);

   WantedPacketsPerSecond.Min      = translate32(WantedPacketsPerSecond.Min);
   WantedPacketsPerSecond.Max      = translate32(WantedPacketsPerSecond.Max);
   WantedPacketsPerSecond.Value    = translate32(WantedPacketsPerSecond.Value);
   WantedExtensionPacketsPerSecond = translate32(WantedExtensionPacketsPerSecond);

   WantedMaxTransferDelay          = translate32(WantedMaxTransferDelay);
   WantedMaxExtensionTransferDelay = translate32(WantedMaxExtensionTransferDelay);

   for(card32 i = 0;i < MaxQualityLevels;i++) {
      QualityLevel[i].BytesPerSecond            = translate64(QualityLevel[i].BytesPerSecond);
      QualityLevel[i].ExtensionBytesPerSecond   = translate64(QualityLevel[i].ExtensionBytesPerSecond);
      QualityLevel[i].FramesPerSecond           = translate32(QualityLevel[i].FramesPerSecond);
      QualityLevel[i].PacketsPerSecond          = translate32(QualityLevel[i].PacketsPerSecond);
      QualityLevel[i].ExtensionPacketsPerSecond = translate32(QualityLevel[i].ExtensionPacketsPerSecond);
      QualityLevel[i].MaxTransferDelay          = translate32(QualityLevel[i].MaxTransferDelay);
      QualityLevel[i].MaxExtensionTransferDelay = translate32(QualityLevel[i].MaxExtensionTransferDelay);
   }
   CurrentSetting.BytesPerSecond            = translate64(CurrentSetting.BytesPerSecond);
   CurrentSetting.ExtensionBytesPerSecond   = translate64(CurrentSetting.ExtensionBytesPerSecond);
   CurrentSetting.FramesPerSecond           = translate32(CurrentSetting.FramesPerSecond);
   CurrentSetting.PacketsPerSecond          = translate32(CurrentSetting.PacketsPerSecond);
   CurrentSetting.ExtensionPacketsPerSecond = translate32(CurrentSetting.ExtensionPacketsPerSecond);
   CurrentSetting.MaxTransferDelay          = translate32(CurrentSetting.MaxTransferDelay);
   CurrentSetting.MaxExtensionTransferDelay = translate32(CurrentSetting.MaxExtensionTransferDelay);
}
*/

// ###### Output operator ###################################################
/*
ostream& operator<<(ostream& os, const TransportInfo& ti)
{
   os << "   WantedBytesPerSecond            = " << ti.WantedBytesPerSecond << endl;
   os << "   WantedExtensionBytesPerSecond   = " << ti.WantedExtensionBytesPerSecond << endl;
   os << "   WantedFramesPerSecond           = " << ti.WantedFramesPerSecond << endl;
   os << "   WantedPacketsPerSecond          = " << ti.WantedExtensionPacketsPerSecond << endl;
   os << "   WantedExtensionPacketsPerSecond = " << ti.WantedExtensionBytesPerSecond << endl;
   os << "   WantedMaxTransferDelay          = " << ti.WantedMaxTransferDelay / 16.0 << endl;
   os << "   WantedMaxExtensionTransferDelay = " << ti.WantedMaxExtensionTransferDelay / 16.0 << endl;
   char str[32];
   sprintf((char*)&str,"$%04x",ti.Flags);
   os << "   Flags                           = " << str << endl;
   sprintf((char*)&str,"$%02x",ti.TrafficClass);
   os << "   TrafficClass                    = " << str << endl;
   sprintf((char*)&str,"$%02x",ti.ExtensionTrafficClass);
   os << "   ExtensionTrafficClass           = " << str << endl;
   for(card32 i = 0;i < ti.QualityLevels;i++) {
      os << "   Level[" << i << "]:" << endl;
      os << "      BytesPerSecond      = " << ti.QualityLevel[i].BytesPerSecond << endl;
      os << "      ExtBytesPerSecond   = " << ti.QualityLevel[i].ExtensionBytesPerSecond << endl;
      os << "      FramesPerSecond     = " << ti.QualityLevel[i].FramesPerSecond << endl;
      os << "      PacketsPerSecond    = " << ti.QualityLevel[i].PacketsPerSecond << endl;
      os << "      ExtPacketsPerSecond = " << ti.QualityLevel[i].ExtensionPacketsPerSecond << endl;
      os << "      MaxTransferDelay    = " << ti.QualityLevel[i].MaxTransferDelay / 16.0 << endl;
      os << "      MaxExtTransferDelay = " << ti.QualityLevel[i].MaxExtensionTransferDelay / 16.0 << endl;
      os << "      Quality             = " << (card32)ti.QualityLevel[i].Quality << " / 255" << endl;
      os << "      LossRate            = " << (card32)ti.QualityLevel[i].LossRate << " / 255" << endl;
      os << "      LevelUp             = " << (card32)ti.QualityLevel[i].LevelUp << endl;
      os << "      LevelDown           = " << (card32)ti.QualityLevel[i].LevelDown << endl;
   }
   os << "   CurrentSetting:" << endl;
   os << "      BytesPerSecond      = " << ti.CurrentSetting.BytesPerSecond << endl;
   os << "      ExtBytesPerSecond   = " << ti.CurrentSetting.ExtensionBytesPerSecond << endl;
   os << "      FramesPerSecond     = " << ti.CurrentSetting.FramesPerSecond << endl;
   os << "      PacketsPerSecond    = " << ti.CurrentSetting.PacketsPerSecond << endl;
   os << "      ExtPacketsPerSecond = " << ti.CurrentSetting.ExtensionPacketsPerSecond << endl;
   os << "      MaxTransferDelay    = " << ti.CurrentSetting.MaxTransferDelay / 16.0 << endl;
   os << "      MaxExtTransferDelay = " << ti.CurrentSetting.MaxExtensionTransferDelay / 16.0 << endl;
   os << "      Quality             = " << (card32)ti.CurrentSetting.Quality << " / 255" << endl;
   os << "      LossRate            = " << (card32)ti.CurrentSetting.LossRate << " / 255" << endl;
   os << "      LevelUp             = " << (card32)ti.CurrentSetting.LevelUp << endl;
   os << "      LevelDown           = " << (card32)ti.CurrentSetting.LevelDown << endl;
   return(os);
}
*/

}
