// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Audio Client App Packet Implementation                           ####
// ####                                                                  ####
// #### Version 1.00  --  February 16, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "system.h"
#include "audioclientapppacket.h"
#include "tools.h"


namespace Coral {


// ###### Constructor #######################################################
AudioClientAppPacket::AudioClientAppPacket()
{
}


// ###### Reset #############################################################
void AudioClientAppPacket::reset()
{
   FormatID        = AudioClientFormatID;
   PosChgSeqNumber = 0;
   SequenceNumber  = 0;
   Status          = ACAS_UnknownCommand;
   SamplingRate    = 0;
   Channels        = 0;
   Bits            = 0;
   Encoding        = 0;
   StartPosition   = (card64)-1;
   RestartPosition = 0;
   BandwidthLimit  = (card32)-1;
   for(cardinal i = 0;i < 128;i++) {
      MediaName[i] = 0x00;
   }
}


// ###### Translate byte order ##############################################
void AudioClientAppPacket::translate()
{
   FormatID        = translate32(FormatID);
   SequenceNumber  = translate16(SequenceNumber);
   PosChgSeqNumber = translate16(PosChgSeqNumber);
   Status          = translate16(Status);
   SamplingRate    = translate16(SamplingRate);
   Encoding        = translate16(Encoding);
   StartPosition   = translate64(StartPosition);
   RestartPosition = translate64(RestartPosition);
   BandwidthLimit  = translate32(BandwidthLimit);
}


}
