#!/bin/sh
# ##########################################################################
# ####                                                                  ####
# ####                      RTP Audio Server Project                    ####
# ####                    ============================                  ####
# ####                                                                  ####
# #### Documentation Generator Script                                   ####
# ####                                                                  ####
# #### Version 1.00, January 05, 2000                                   ####
# ####                                                                  ####
# #### Copyright (C) 1999  Thomas Dreibholz                             ####
# ####               2000  Universitt Bonn, Abt. IV                    ####
# ####                     EMail: Dreibholz@bigfoot.com                 ####
# ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
# ####                                                                  ####
# ##########################################################################


echo ""
echo "Removing old documentation..."
echo ""

if [ -e Documentation ]
then
   rm -Rf Documentation
fi   

if [ -e JavaDocumentation ]
then
   rm -Rf JavaDocumentation
fi   
mkdir JavaDocumentation


echo ""
echo "Generating new documentation..."
echo ""

kdoc -f html -d Documentation -n "RTP Audio Project" *.h
/usr/lib/jdk1.3/bin/javadoc -d JavaDocumentation -version -author -windowtitle "RTP Audio Project - Java Documentation" -doctitle "RTP Audio Project" Java/*.java


echo ""
echo "Modifying layout..."
echo ""

find -name "*.html" | xargs -n 1 UpdateDocFile.sh

echo ""
echo "Documentation complete!"
echo ""
