// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Congestion Manager Packet Implementation                         ####
// ####                                                                  ####
// #### Version 1.00  --  February 16, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "system.h"
#include "congestionmanagerpacket.h"
#include "tools.h"
#include "transportinfo.h"


namespace Coral {


// ###### Constructor #######################################################
CongestionManagerPacket::CongestionManagerPacket()
{
}


// ###### Reset #############################################################
void CongestionManagerPacket::reset()
{
   PacketID       = 0;
   SequenceNumber = 0;
   Type           = 0;
   Length         = 0;   
}


// ###### Translate byte order ##############################################
void CongestionManagerPacket::translate()
{
   PacketID       = translate16(PacketID);
   SequenceNumber = translate16(SequenceNumber);
   Type           = translate16(Type);
   Length         = translate16(Length);
}


// ###### Constructor #######################################################
CongestionManagerRequest::CongestionManagerRequest()
   : CongestionManagerPacket()
{
}


// ###### Reset #############################################################
void CongestionManagerRequest::reset()
{
   CongestionManagerPacket::reset();
   Identifier = 0;
   ReplyTo.reset();
   StreamDescription.reset();
}


// ###### Translate byte order ##############################################
void CongestionManagerRequest::translate()
{
   CongestionManagerPacket::translate();
   StreamDescription.translate();
   Identifier = translate32(Identifier);
}


// ###### Constructor #######################################################
CongestionManagerSuggestion::CongestionManagerSuggestion()
   : CongestionManagerPacket()
{
}


// ###### Reset #############################################################
void CongestionManagerSuggestion::reset()
{
   CongestionManagerPacket::reset();
   Identifier = 0;
   Suggestion.reset();
}


// ###### Translate byte order ##############################################
void CongestionManagerSuggestion::translate()
{
   CongestionManagerPacket::translate();
   Identifier = translate32(Identifier);
}


}
