// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Congestion Monitor Report Implementation                         ####
// ####                                                                  ####
// #### Version 1.00  --  February 23, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "system.h"
#include "congestionmonitorreport.h"
#include "congestionmanagerpacket.h"
#include "tools.h"


namespace Coral {


// ###### Constructor #######################################################
CongestionMonitorReport::CongestionMonitorReport()
{
   reset();
}


// ###### Reset #############################################################
void CongestionMonitorReport::reset()
{
   NetworkMonitorReport::reset();
   SeqNum     = 0;
   Congestion = 0;
   Bandwidth  = 0;
}


// ###### Translate byte order ##############################################
void CongestionMonitorReport::translate()
{
   NetworkMonitorReport::translate();
   SeqNum     = translate32(SeqNum);
   Congestion = translate32(Congestion);
   Bandwidth  = translate64(Bandwidth);
}


// ###### << operator #######################################################
ostream& operator<<(ostream& os, const CongestionMonitorReport& report)
{
   char buffer[1024];
   snprintf((char*)&buffer,sizeof(buffer),
           "bw=%Ld cg=%1.3f%%  ",
           report.Bandwidth,(100.0 * (double)report.Congestion) / 65536.0);
   os << buffer;
   os << (NetworkMonitorReport)report;
   return(os);
}


}
