package bonn.infoIV.v3d2.util;

import java.io.DataOutput;
import java.io.IOException;

public class IntArrayToByteArray
{
  private static final int FIRST_BYTE  = 0xFF000000;
  private static final int SECOND_BYTE = 0x00FF0000;
  private static final int THIRD_BYTE  = 0x0000FF00;
  private static final int FOURTH_BYTE = 0x000000FF;

  protected DataOutput Out_ = null;

  public IntArrayToByteArray(DataOutput out)
  {
    super();
    Out_=out;
  }

  public void writeInt(int[] a) throws IOException
  {
    byte[] b = new byte[4*a.length];
    for(int i=0 ; i<a.length ; i++)
    {
      b[i*4  ] = (byte)((a[i] & FIRST_BYTE)  >>>24); 
      b[i*4+1] = (byte)((a[i] & SECOND_BYTE) >>>16);
      b[i*4+2] = (byte)((a[i] & THIRD_BYTE)  >>> 8);
      b[i*4+3] = (byte) (a[i] & FOURTH_BYTE);
    }
    Out_.write(b);
  }

  public static byte[] toByte(int[] a)
  {
    byte[] b = new byte[4*a.length];
    for(int i=0 ; i<a.length ; i++)
    {
      b[i*4  ] = (byte)((a[i] & FIRST_BYTE)  >>>24); 
      b[i*4+1] = (byte)((a[i] & SECOND_BYTE) >>>16);
      b[i*4+2] = (byte)((a[i] & THIRD_BYTE)  >>> 8);
      b[i*4+3] = (byte) (a[i] & FOURTH_BYTE);
    }
    return b;
  }

}
