package mpi_graphics;

import java.io.*;
import java.lang.*;

import bonn.infoIV.v3d2.buffer.Object3D;//STAVROS
import java.util.Arrays;//STAVROS

public class Binary_Sequentiel_Loader_PM_Bonn extends Binary_Sequentiel_Loader
{
  protected int ActualSplitCount_ = 0;

// ************************************************************************************
// read_PM_header
// ************************************************************************************
    public void read_PM_header(PM_Info info, boolean frame, int objId)//STAVROS
    {
      ActualSplitCount_=0;
      int[] sizes = MySyncBuffer_.getInfo(frame, objId);
      // Lese Header
      info.set_vertex_count(sizes[Object3D.VERTEX_COUNT]);
      info.set_triangle_count(sizes[Object3D.TRIANGLE_COUNT]);
      info.set_vertex_split_count(sizes[Object3D.SPLIT_COUNT]);
//       System.out.print("Gelesen: Vertex  count     :" +sizes[Object3D.VERTEX_COUNT]);
//       System.out.print(": Triangle count    :" +sizes[Object3D.TRIANGLE_COUNT]);
//       System.out.println(": Vertex-splis count:" +sizes[Object3D.SPLIT_COUNT]);
//       Arrays.fill(sizes, 0); // Setzte das Info-Feld auf 0
//       MySyncBuffer_.setInfo(frame, objId, sizes);
    }

// ************************************************************************************
// read_next_vertex
// ************************************************************************************
    public void read_next_vertex(float[] v) throws IOException
    {
	v[0]=Sdis_.readFloat();
	v[1]=Sdis_.readFloat();
	v[2]=Sdis_.readFloat();
    }
        
// ************************************************************************************
// read_next_triangle
// ************************************************************************************
    public void read_next_triangle(int[] triangle_indices) throws IOException
    {
	triangle_indices[0]=Sdis_.readInt();
	triangle_indices[1]=Sdis_.readInt();
	triangle_indices[2]=Sdis_.readInt();
    }
    
// ************************************************************************************
// read_pm_mesh
// ************************************************************************************
   public boolean read_pm_mesh(int anz_splits, Mesh_Geometry_Array mesh_array, boolean frame, int objId)//STAVROS
   {
     float[] v = new float[3];             // one Vertex consisting of 3 floats.
     int[]   triangleIndices = new int[3]; // one Triangle consisting of 3 int coordinates.
     int     i=0;                          // counter for FOR-loops
     int     vertexBytesCount = 3*4*mesh_array.num_vertices_base; // actual Count of Vertices in the base mesh
     byte[]  b = new byte [vertexBytesCount+3*4*mesh_array.num_triangles_base];
     int     size = vertexBytesCount+3*4*mesh_array.num_triangles_base;

     ActualSplitCount_ = 0;

     if(frame)  b = MySyncBuffer_.get(Object3D.BASE_MESH, objId);
     else b = MySyncBuffer_.get(Object3D.BASE_MESH2, objId);

     if((size<3) || ((b[size-1]==Object3D.ZERO) && (b[size-2]==Object3D.ZERO) && (b[size-3]==Object3D.ZERO)))
     { 
       System.out.println("___BaseMesh nicht Anzeigbar, da fehlerhaft"); 
       return false; // nicht richtig empfangen!!!!
     }
     

     for (i=0 ; i<mesh_array.num_vertices_base ; i++)
     {
       v[0] = Float.intBitsToFloat(((b[12*i] & 0xff)<<24)
                                  +((b[12*i+1] & 0xff)<<16)
                                  +((b[12*i+2] & 0xff)<<8)
                                  +((b[12*i+3] & 0xff)));
       v[1] = Float.intBitsToFloat(((b[12*i+4] & 0xff)<<24)
                                  +((b[12*i+5] & 0xff)<<16)
                                  +((b[12*i+6] & 0xff)<<8)
                                  +((b[12*i+7] & 0xff)));
       v[2] = Float.intBitsToFloat(((b[12*i+8] & 0xff)<<24)
                                  +((b[12*i+9] & 0xff)<<16)
                                  +((b[12*i+10] & 0xff)<<8)
                                  +((b[12*i+11] & 0xff)));
       mesh_array.set_vertex(i,v);
       //System.out.println("Knoten No.:" +i +" ist:" +v[0] +"," +v[1] +"," +v[2]);
     }

     for (i=0; i<mesh_array.num_triangles_base; i++)
     {
       triangleIndices[0] = ((b[vertexBytesCount+12*i] & 0xff)<<24)
                            +((b[vertexBytesCount+12*i+1] & 0xff)<<16)
                            +((b[vertexBytesCount+12*i+2] & 0xff)<<8)
                            +((b[vertexBytesCount+12*i+3] & 0xff));
       triangleIndices[1] = ((b[vertexBytesCount+12*i+4] & 0xff)<<24)
                            +((b[vertexBytesCount+12*i+5] & 0xff)<<16)
                            +((b[vertexBytesCount+12*i+6] & 0xff)<<8)
                            +((b[vertexBytesCount+12*i+7] & 0xff));
       triangleIndices[2] = ((b[vertexBytesCount+12*i+8] & 0xff)<<24)
                            +((b[vertexBytesCount+12*i+9] & 0xff)<<16)
                            +((b[vertexBytesCount+12*i+10] & 0xff)<<8)
                            +((b[vertexBytesCount+12*i+11] & 0xff));
       if((triangleIndices[0] <0) || (triangleIndices[1] <0) || (triangleIndices[2] <0) ||
          (triangleIndices[0] >mesh_array.num_triangles_base) || 
          (triangleIndices[1] >mesh_array.num_triangles_base) || 
          (triangleIndices[2] >mesh_array.num_triangles_base))
       {
         System.out.println("___Dreiecke sind falsch");
         //if(frame)  MySyncBuffer_.resetArray(Object3D.BASE_MESH, objId, b.length);
         //else MySyncBuffer_.resetArray(Object3D.BASE_MESH2, objId, b.length);
         return false;
       }
       mesh_array.set_vertex_indices(i, triangleIndices);
       //System.out.println("Dreieck No.:" +i +" ist:" +triangleIndices[0] +"," +triangleIndices[1] +"," +triangleIndices[2]);
     }

     // Dies ist noetig, denke ich, weil wir immer ins selbe Array schreiben!!!!
     //if(frame)  MySyncBuffer_.resetArray(Object3D.BASE_MESH, objId, b.length);
     //else MySyncBuffer_.resetArray(Object3D.BASE_MESH2, objId, b.length);
     //System.out.println("BaseMesh ist okey");
     read_vertex_splits(anz_splits,mesh_array, frame, objId, mesh_array.num_vertices_base); 
     return true;
   }

   public int getActualSplitCount() { return ActualSplitCount_; }//STAVROS


// ************************************************************************************
// read_base_mesh
// ************************************************************************************
   public void read_base_mesh(PM_Info info, Mesh_Geometry mesh) throws IOException
    {
	float[] v = new float[3];
	int[] triangle_indices = new int[3];
	int i;
	
	// Lese die Vertices des Base-Mesh ein
	//System.out.println("Lese Vertices der PM-Datei");
	for (i=0;i<info.get_vertex_count();i++)
	    {
		read_next_vertex(v);

		// Schreibe Vertex in Vertexliste
		mesh.set_vertex(i,v);
		//System.out.println(v);
	    }

	// Lese die Dreiecke des Base-Mesh ein
	//System.out.println("Lese Dreiecke der PM-Datei");
	for (i=0;i<info.get_triangle_count();i++)
	    {
		read_next_triangle(triangle_indices);

		// Schreibe Dreieck in Dreieckliste
		mesh.set_vertex_indices(i, triangle_indices);
		//System.out.println(triangle_indices[0]);
	    }
	    
	mesh.set_act_mesh_info(info);
    }
    
// ************************************************************************************
// read_next_vertex_split
// ************************************************************************************
   public void read_next_vertex_split(Vertex_Split vsplit) throws IOException
    {
	int[] split_index = new int[3];
	float[] split_coord = new float[3];
	
	split_index[0]=Sdis_.readInt();
	split_index[1]=Sdis_.readInt();
	split_index[2]=Sdis_.readInt();
	split_coord[0]=Sdis_.readFloat();
	split_coord[1]=Sdis_.readFloat();
	split_coord[2]=Sdis_.readFloat();

	vsplit.set_vertex_split(split_index,split_coord);
    }

// ************************************************************************************
// read_vertex_splits
// ************************************************************************************
  public void read_vertex_splits(int anz_splits, Mesh_Geometry_Array mesh_array, boolean frame, int objId, int v)
  {
    int[]   split_index = new int[3];
    float[] split_coord = new float[3];
    int i;
    byte[] b = new byte [24*anz_splits];
    int maxVertex = v;	
    //System.out.println("anzahl Splits ist gleich: " +anz_splits);

    if(frame) b = MySyncBuffer_.get(Object3D.VERTEX_SPLITS, objId);
    else b = MySyncBuffer_.get((byte)(Object3D.VERTEX_SPLITS+1), objId);

    for (i=0;i<anz_splits;i++)
    {
      split_index[0] = ((b[24*i] & 0xff)<<24)
                      +((b[24*i+1] & 0xff)<<16)
                      +((b[24*i+2] & 0xff)<<8)
                      +((b[24*i+3] & 0xff));
      split_index[1] = ((b[24*i+4] & 0xff)<<24)
                      +((b[24*i+5] & 0xff)<<16)
                      +((b[24*i+6] & 0xff)<<8)
                      +((b[24*i+7] & 0xff));
      split_index[2] = ((b[24*i+8] & 0xff)<<24)
                      +((b[24*i+9] & 0xff)<<16)
                      +((b[24*i+10] & 0xff)<<8)
                     +((b[24*i+11] & 0xff));

      if((split_index[0]>maxVertex) || (split_index[0]<0) || 
         (split_index[1]>maxVertex) || (split_index[1]<0) || 
         (split_index[2]>maxVertex) || (split_index[2]<0))
      {
        //if (i<=10) { ActualSplitCount_ = 0; }//System.out.println("REDUCED............");}
	//else ActualSplitCount_ = i;
        System.out.println("___Falsche Vertex-Splits!");
        return;
      }

      split_coord[0] = Float.intBitsToFloat(((b[24*i+12] & 0xff)<<24)
                                           +((b[24*i+13] & 0xff)<<16)
                                           +((b[24*i+14] & 0xff)<<8)
                                           +((b[24*i+15] & 0xff)));
      split_coord[1] = Float.intBitsToFloat(((b[24*i+16] & 0xff)<<24)
                                           +((b[24*i+17] & 0xff)<<16)
                                           +((b[24*i+18] & 0xff)<<8)
                                           +((b[24*i+19] & 0xff)));
      split_coord[2] = Float.intBitsToFloat(((b[24*i+20] & 0xff)<<24)
                                           +((b[24*i+21] & 0xff)<<16)
                                           +((b[24*i+22] & 0xff)<<8)
                                           +((b[24*i+23] & 0xff)));

      mesh_array.set_vertex_split_indices(i,split_index);
      mesh_array.set_vertex(mesh_array.num_vertices_base+i,split_coord);
      maxVertex++;
      ActualSplitCount_++;
    }
    //System.out.println("MaxVertex maximum Ende" +maxVertex);
     // Dies ist noetig, denke ich, weil wir immer ins selbe Array schreiben!!!!
    //if(frame)  MySyncBuffer_.resetArray(Object3D.VERTEX_SPLITS, objId, b.length);
    //else MySyncBuffer_.resetArray((byte)(Object3D.VERTEX_SPLITS+1), objId, b.length);


    //skip_PM(mesh_array.num_vertex_splits-anz_splits);
  }

// ************************************************************************************
// skip_base_mesh
// ************************************************************************************
   public void skip_base_mesh(PM_Info info) throws IOException
    {
	long byte_number;
	
	// Ueberspringe die Vertices des Base-Mesh 
	byte_number=info.get_vertex_count()*3*4;
	Sdis_.skip(byte_number);
	
	// Ueberspringe die Dreiecke des Base-Mesh
	byte_number=info.get_triangle_count()*3*4;
	Sdis_.skip(byte_number);
    }
    
// ************************************************************************************
// skip_PM
// ************************************************************************************
    public void skip_PM(int v_split_number) throws IOException
    {	
	long byte_number;
	
	byte_number=v_split_number*6*4;

	Sdis_.skip(byte_number);
    }
}
