package mpi_graphics;

public class Mesh_Geometry_Array 
{
    public float[] vertex_array;
    public int[] index_array_base;
    protected int[][] vertex_split_indices;

    protected int num_vertices_max = -8;
    protected int num_vertices_base = -7;
    protected int num_triangles_base = -6;
    protected int num_vertex_splits = -5;
    
// ************************************************************************************
// Mesh_Geometry_Array
// ************************************************************************************
    public Mesh_Geometry_Array()
    {
    }
    
// ************************************************************************************
// Mesh_Geometry_Array  MODIFIED BY STAVROS
// ************************************************************************************
    public Mesh_Geometry_Array(PM_Info info)
    {
	resize(info);
	
	vertex_array=new float[3*num_vertices_max];
	index_array_base=new int[3*num_triangles_base];
	vertex_split_indices=new int[num_vertex_splits][3];
    }
    
// ************************************************************************************
// resize
// ************************************************************************************
    final public void resize(PM_Info info)
    {
	num_vertices_base=info.get_vertex_count();
	num_triangles_base=info.get_triangle_count();
	num_vertex_splits=info.get_vertex_split_count();
	num_vertices_max=num_vertices_base+num_vertex_splits;
    }
    

// ************************************************************************************
// get_num_vertices_base
// ************************************************************************************
    final public int get_num_vertices_base()
    {
	return num_vertices_base;
    }
    
// ************************************************************************************
// get_num_triangles_base
// ************************************************************************************
    final public int get_num_triangles_base()
    {
	return num_triangles_base;
    }
    
// ************************************************************************************
// set_vertex
// ************************************************************************************
    final public void set_vertex(int i, float[] vertex)
    {
	vertex_array[3*i+0]=vertex[0];
	vertex_array[3*i+1]=vertex[1];
	vertex_array[3*i+2]=vertex[2];
    }
    
// ************************************************************************************
// get_vertex
// ************************************************************************************
    final public void get_vertex(int i, float[] vertex)
    {
	vertex[0]=vertex_array[3*i+0];
	vertex[1]=vertex_array[3*i+1];
	vertex[2]=vertex_array[3*i+2];
    }
    
// ************************************************************************************
// set_vertex_indices
// ************************************************************************************
    final public void set_vertex_indices(int t_number, int[] v_number)
    {
	index_array_base[3*t_number+0]=v_number[0];
	index_array_base[3*t_number+1]=v_number[1];
	index_array_base[3*t_number+2]=v_number[2];
    }

// ************************************************************************************
// get_vertex_indices
// ************************************************************************************
    final public void get_vertex_indices(int t_number, int[] v_number)
    {
	v_number[0]=index_array_base[3*t_number+0];
	v_number[1]=index_array_base[3*t_number+1];
	v_number[2]=index_array_base[3*t_number+2];
    }

// ************************************************************************************
// set_vertex_split_indices
// ************************************************************************************
    final public void set_vertex_split_indices(int i, int[] v_number)
    {
	vertex_split_indices[i][0]=v_number[0];
	vertex_split_indices[i][1]=v_number[1];
	vertex_split_indices[i][2]=v_number[2];
    }

// ************************************************************************************
// get_vertex_split_indices
// ************************************************************************************
    final public void get_vertex_split_indices(int i, int[] v_number)
    {
	v_number[0]=vertex_split_indices[i][0];
	v_number[1]=vertex_split_indices[i][1];
	v_number[2]=vertex_split_indices[i][2];
    }
}
