#ifndef RTP_RTCP_COMMON_H
#define RTP_RTCP_COMMON_H

/* The type definitions below are valid for 32-bit architectures and
   may have to be adjusted for 16- or 64-bit architectures. */

//#ifdef ILP32..LP64
//POSIX.1g data types in <sys/types.h>:
//int8_t,  uint8_t
//int16_t, uint16_t
//int32_t, uint32_t
//GNU extension: int64_t, uint64_t

typedef signed char    s_int08;
typedef unsigned char  u_int08;
typedef signed short   s_int16;
typedef unsigned short u_int16;
typedef signed int     s_int32;
typedef unsigned int   u_int32;

const u_int16 RTP_MIN_PORT = (unsigned short) 5000; // Minimum port number for RTP
const u_int16 RTP_MAX_PORT = (unsigned short)   -1; // Maximum port number for RTP

const u_int16 RTP_VERSION     = 2;		    // Current protocol version
const u_int32 RTP_SEQ_MOD     = 1<<16;              // Maximum sequence number (16-Bit)

/* Big-endian mask for version, padding bit and packet type pair */
const u_int16 RTCP_VALID_MASK    = (0xc000 | 0x2000 | 0xfe);
//const u_int16 RTCP_VALID_VALUE = ((RTP_VERSION << 14) | RTCP_SR);

const u_int16 RTP_MAX_SDES = 255;	            // Maximum text length for SDES

#endif
