// gui.hh --- GUI Class Header File

#ifndef GUI_CLASS
#define GUI_CLASS

#include <qtabdialog.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qlcdnumber.h>

static const char *openPixmap[] =
{
"    16    13        5            1",
". c #040404",
"# c #808304",
"a c #bfc2bf",
"b c #f3f704",
"c c #f3f7f3",
"aaaaaaaaa...aaaa",
"aaaaaaaa.aaa.a.a",
"aaaaaaaaaaaaa..a",
"a...aaaaaaaa...a",
".bcb.......aaaaa",
".cbcbcbcbc.aaaaa",
".bcbcbcbcb.aaaaa",
".cbcb...........",
".bcb.#########.a",
".cb.#########.aa",
".b.#########.aaa",
"..#########.aaaa",
"...........aaaaa"
};

static const char *closePixmap[] =
{
"    14    14        3            1",
". c #040404",
"# c #808304",
"a c #bfc2bf",
"..............",
".#.aaaaaaaa.a.",
".#.aaaaaaaa...",
".#.aaaaaaaa.#.",
".#.aaaaaaaa.#.",
".#.aaaaaaaa.#.",
".#.aaaaaaaa.#.",
".##........##.",
".############.",
".##.........#.",
".##......aa.#.",
".##......aa.#.",
".##......aa.#.",
"a............."
};

static const char *helpPixmap[] =
{
"    16    14        5            1",
". c #000000",
"# c #848284",
"a c #c6c3c6",
"b c #ffff00",
"c c #ffffff",
"aaaaa.........aa",
"aaaa.cccccccc.aa",
"aaaa.c.....c.aaa",
"aaa.cccccccc.aaa",
"aaa.c.....c....a",
"aa.cccccccc.a.a.",
"a..........a.a..",
".aaaaaaaaaa.a.a.",
".............aa.",
".aaaaaa###aa.a.a",
".aaaaaabbbaa...a",
".............a.a",
"a.aaaaaaaaa.a.aa",
"aa...........aaa"
};

class MenuBar : public QMenuBar
{
public:
  MenuBar(QWidget * = NULL, const char * = NULL);
};

class ToolBar : public QToolBar
{
public:
  ToolBar(QMainWindow * = NULL, const char * = NULL);
};

class StatusBar : public QStatusBar
{
public:
  StatusBar(QWidget * = NULL, const char * = NULL);
};

class TransportAddressWidget : public QGroupBox
{
public:
  TransportAddressWidget(QString, QString, QString, QString, QWidget * = NULL, const char * = NULL);
public:
  QLabel *hostname_label;
  QLabel *ipaddress_label;
  QLabel *port_label;

  QLabel *hostname_val;
  QLabel *ipaddress_val;
  QLabel *port_val;

  QGridLayout *glayout;
};

class TransportAddressesWidget : public QWidget
{
public:
  TransportAddressesWidget(QWidget * = NULL, const char * = NULL);
public:
  TransportAddressWidget *local_host;
  TransportAddressWidget *remote_host;

  QGridLayout *glayout;
};

class FileStatusWidget : public QWidget
{
public:
  FileStatusWidget(QWidget * = NULL, const char * = NULL);
public:
  QLCDNumber *f_snt;
  QLCDNumber *f_rem;
  QLCDNumber *f_tot;
  QLCDNumber *f_all;

  QGridLayout *glayout;
};

class TabDialog : public QTabDialog
{
public:
  TabDialog(QWidget * = NULL, const char * = NULL);
//~TabDialog();
public:
  TransportAddressesWidget *transportAddr;
  FileStatusWidget *fileStatus;
};

#endif
